#ifndef __DEM_H__
#define __DEM_H__

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <stdint.h>
#include <math.h>
#include <unistd.h>
#include <pthread.h>
#include "Globals.h"
#include "Life.h"
#include "OpenGL.h"

extern struct Species ***life;
extern struct Stats *stats;
extern struct Stats_T stats_t;
extern struct image_attr *ia;
extern unsigned int Threads;
extern char *filename_dem;
extern char *filename_backup_save;
extern char *filename_backup_load;
extern double Backup_Freq_Runtime;
extern double Year_Runtime;
extern unsigned char **Alive;

//adjusts sea levels by 1m when called
void Adjust_Sea_Level(int load);
//adjust climate by .2C
void Adjust_Climate(int load);
//loads file data into **data, allocates initial image
int Load_Terrain(void);
void Gen_Detailed_Counts(void);
int Save_Current_State(void);
int Load_State(void);

#endif