#ifndef __LIFE_H__
#define __LIFE_H__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>
#include <sys/time.h>
#include <stdint.h>
#include <sys/types.h>
#include <string.h>
#include "Globals.h"
#include "DEM.h"
#include "Random.h"

extern struct Species ***life;
extern struct Stats *stats;
extern struct Stats_T stats_t;
extern struct image_attr *ia;
extern struct Thread_I *Actions_t_info;
//extern char **fought;
//extern char **mated;
extern char *life_speed_up_X;
extern char *life_speed_up_Y;
extern pthread_barrier_t Barrier1;
extern pthread_barrier_t Barrier2;
//extern pthread_barrier_t Barrier3;
extern pthread_barrierattr_t Barrier1_Attr;
extern pthread_barrierattr_t Barrier2_Attr;
//extern pthread_barrierattr_t Barrier3_Attr;
extern pthread_mutex_t Mutex1;
extern pthread_mutex_t Mutex2;
extern pthread_mutex_t Mutex3;
extern int Stats_Handled;
//extern uint32_t Threads;
extern double Year_Runtime;
extern double Backup_Freq_Runtime;
extern uint32_t Backup_Freq;
extern int No_Exit;
extern uint32_t Thread_Step;
extern struct timeval Year_Starttime,Year_Endtime;
//extern unsigned char Alive[HEIGHT][WIDTH/8+1];
//extern unsigned char Fought[HEIGHT][WIDTH/8+1];
//extern unsigned char Mated[HEIGHT][WIDTH/8+1];
extern unsigned char **Alive;
extern unsigned char **Fought;
extern unsigned char **Mated;


//int Is_Alive(uint32_t src_y, uint32_t src_x);
//int Has_Mated(uint32_t src_y, uint32_t src_x);
//int Has_Fought(uint32_t src_y, uint32_t src_x);
void KILL_Tribe(uint32_t y, uint32_t x);
int Tribe_Migrate(uint32_t src_y, uint32_t src_x, uint32_t *dest);
int Fight_Tribe(struct Species *one, struct Species *two);
void Tribe_Interactions(uint32_t src_y, uint32_t src_x, uint32_t tid);
void FM_Reset(uint32_t start, uint32_t end);
int Tribe_Move_To_Water(uint32_t src_y, uint32_t src_x, uint32_t *dest);
int Tribe_Water_Migrate(uint32_t src_y, uint32_t src_x, uint32_t *dest);
int Tribe_Borders_Water(uint32_t src_y, uint32_t src_x);
void Allocate_Life_Array(void);
//void FM_Alloc(uint32_t height, uint32_t width);
//void FM_Reset(uint32_t height, uint32_t width);
//void FM_Alloc(void);
void Gen_Tribe_Color(struct Species *one, unsigned char *rgb);
void Add_First_Life(struct Species *one);
int Is_Same_Species(struct Species *one, struct Species *two);
void Create_Life(struct Species *one, struct Species *two, struct Species *three);
float Location_Temp(uint32_t src_y, uint32_t src_x);
int Climate_Fatal(struct Species *one, uint32_t src_y, uint32_t src_x);
void *Tribe_Actions(void *tid);
//void *Drawl_Image_PT(void *tid);
void Drawl_Image(void);

#endif